import java.net.Socket;

//---------------------------------------------------------------------------
// LMRecord: Used to store per-request information
//---------------------------------------------------------------------------
public class LMRecord{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public LMRecord(Socket replySocket, int lockToken, long seqNum)
    {
	this.replySocket = replySocket;
	this.lockToken = lockToken;
	this.seqNum = seqNum;
    }

    //-----------------------------------------------------------------------
    // Return the socket expecting a reply
    //-----------------------------------------------------------------------
    public Socket getReplySocket()
    {
	return(this.replySocket);
    }

    //-----------------------------------------------------------------------
    // Return the lock token
    //-----------------------------------------------------------------------
    public int getLockToken()
    {
	return(this.lockToken);
    }

    //-----------------------------------------------------------------------
    // Return the sequence number
    //-----------------------------------------------------------------------
    public long getSeqNum()
    {
	return(this.seqNum);
    }

    //-----------------------------------------------------------------------
    // Used for testing
    //-----------------------------------------------------------------------
    public static void main(String[] argv)
    {
	LMRecord record = null;

	record = new LMRecord(null, 30, 25);
	System.out.println("getReplySocket = " + record.getReplySocket());
	System.out.println("getLockToken = " + record.getLockToken());
	System.out.println("getSeqNum = " + record.getSeqNum());
    }

    //-----------------------------------------------------------------------
    // Private data
    //-----------------------------------------------------------------------
    private Socket replySocket;
    private int lockToken;
    private long seqNum;
}
