import java.net.Socket;

//---------------------------------------------------------------------------
// AppMessage: An interface that all used message classes must implement
//---------------------------------------------------------------------------
public interface AppMessage{

    //-----------------------------------------------------------------------
    // Methods
    //-----------------------------------------------------------------------
    public long getSeqNum();
    public int getMessageType();
    public String getObjectID();
    public boolean containsLock();
    public int getLockToken();
    public byte[] getData();
    public Socket getReplySocket();
    public long getTimeStamp();

    //-----------------------------------------------------------------------
    // Constants
    //-----------------------------------------------------------------------
    public static final int READ = 1;
    public static final int DATA = 2;
    public static final int INV = 3;
    public static final int ACK = 4;
    public static final int LMOP_ACQUIRE_EXCLUSIVE = 5;
    public static final int LMOP_ACQUIRE_SHARED = 6;
    public static final int LMOP_UPGRADE = 7;
    public static final int LMOP_DOWNGRADE = 8;
    public static final int LMOP_RELEASE = 9;
    public static final int LMREP_GRANTED_SHARED = 10;
    public static final int LMREP_GRANTED_EXCLUSIVE = 11;
    public static final int READ_FINISHED = 12;
}
