//---------------------------------------------------------------------------
// FSCommConnection: Listens to requests from a single connection
//---------------------------------------------------------------------------
import java.net.Socket;
import java.io.InputStream;
import java.io.IOException;

public class FSCommConnection implements Runnable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public FSCommConnection(ReplicaFSM replicaFSM, Socket socket)
    {
	this.replicaFSM = replicaFSM;
	this.socket = socket;
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	InputStream is = null;
	FSCommPacket fsPacket = null;

	try{
	    is = this.socket.getInputStream();
	    while(true){
		fsPacket = new FSCommPacket(is, this.socket);
		Globals.debugPrintln("FSCommConnection: Got a request");
		Globals.debugPrintln("type = " + fsPacket.getMessageType());
		Globals.debugPrintln("objectID = " + fsPacket.getObjectID());
		Globals.debugPrintln("");
		this.replicaFSM.applyMsg(fsPacket);
	    }
	}catch(IOException e){
	    System.err.println("" + e);
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected Socket socket;
    protected ReplicaFSM replicaFSM;
}
