//---------------------------------------------------------------------------
// FSCommPoint: Simple class used to communicate with the FS
//---------------------------------------------------------------------------
import java.net.Socket;
import java.io.IOException;
import java.io.OutputStream;

// Used for testing
import java.net.ServerSocket;

public class FSCommPoint{

    //-----------------------------------------------------------------------
    // Send an acknowledgment over the given socket
    //-----------------------------------------------------------------------
    public static void sendAck(String objectID, int lockToken, Socket socket)
    {
	OutputStream os = null;
	FSCommPacket fsPacket = null;

	try{
	    os = socket.getOutputStream();
	    fsPacket = new FSCommPacket(AppMessage.ACK, lockToken, objectID);
	    fsPacket.sendSelf(os);
	    /*
	      os.flush();
	      os.close();
	      socket.close();
	    */
	}catch(IOException e){
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Used for testing
    //-----------------------------------------------------------------------
    public static void main(String[] argv)
    {
	Socket s = null;
	FSCommPacket p = null;

	new FSCommPointDummyServer();
	try{
	    s = new Socket("localhost", 5000);
	    s.setTcpNoDelay(true);
	    p = new FSCommPacket(s.getInputStream(), s);
	    System.out.println("Got packet");
	    System.out.println("LockToken = " + p.getLockToken());
	    System.out.println("ObjectID = " + p.getObjectID());
	    System.out.println("Replysock portnum = " +
			       (p.getReplySocket()).getPort());
	    System.out.println("Requestsock portnum = " + s.getPort());
	}catch(IOException e){
	    System.err.println("" + e);
	}
    }
}

//---------------------------------------------------------------------------
// FSCommPointDummyServer: Used to get a socket endpoint for testing
//---------------------------------------------------------------------------
class FSCommPointDummyServer implements Runnable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public FSCommPointDummyServer()
    {
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	ServerSocket ss = null;
	Socket s = null;

	try{
	    ss = new ServerSocket(5000);
	    s = ss.accept();
	    s.setTcpNoDelay(true);
	    FSCommPoint.sendAck("o", 2, s);
	}catch(IOException e){
	    System.err.println("" + e);
	}
    }
}
