//---------------------------------------------------------------------------
// FSCommServer: Listens to requests from the FS
//---------------------------------------------------------------------------
import java.net.Socket;
import java.net.ServerSocket;
import java.io.IOException;

public class FSCommServer implements Runnable{

    //-----------------------------------------------------------------------
    // Constants
    //-----------------------------------------------------------------------
    public static final int PORT_NUM = 8888;

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public FSCommServer(ReplicaFSM replicaFSM)
    {
	this.replicaFSM = replicaFSM;
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	Socket socket = null;
	ServerSocket serverSocket = null;

	try{
	    serverSocket = new ServerSocket(FSCommServer.PORT_NUM);
	    while(true){
		socket = serverSocket.accept();
		socket.setTcpNoDelay(true);
		new FSCommConnection(this.replicaFSM, socket);
	    }
	}catch(IOException e){
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected ReplicaFSM replicaFSM;
}
