//---------------------------------------------------------------------------
// FileStateTable: Repository of file states
//---------------------------------------------------------------------------
import java.util.Hashtable;

public class FileStateTable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public FileStateTable()
    {
	this.table = new Hashtable();
    }

    //-----------------------------------------------------------------------
    // Return the state associated with file "objectID"
    //-----------------------------------------------------------------------
    public FileState get(String objectID)
    {
	FileState fileState = null;

	fileState = (FileState)this.table.get(objectID);
	if(fileState == null){
	    fileState = new FileState(objectID);
	    this.table.put(objectID, fileState);
	}
	return(fileState);
    }

    //-----------------------------------------------------------------------
    // Remove the state associated with file "objectID"
    //-----------------------------------------------------------------------
    public void remove(String objectID)
    {
	this.table.remove(objectID);
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected Hashtable table;
}
