//---------------------------------------------------------------------------
// LMListener: Thread used to communicate with the lock manager
//---------------------------------------------------------------------------
import java.net.Socket;
import java.io.InputStream;
import java.io.IOException;
import java.util.Hashtable;

public class LMListener implements Runnable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public LMListener(Socket socket, Hashtable mailBoxTable)
    {
	this.socket = socket;
	this.mailBoxTable = mailBoxTable;
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	Long reqIDLong = null;
	AppMessage msg = null;
	InputStream is = null;
	LMMailBox mailBox = null;
	LMReplyPacket reply = null;

	try{
	    is = this.socket.getInputStream();
	    while(true){
		reply = new LMReplyPacket(is);
		reqIDLong = new Long(reply.getSeqNum());
		mailBox = (LMMailBox)this.mailBoxTable.remove(reqIDLong);
		assert(mailBox != null);
		mailBox.lockArrived(reply);
		reply = null;
	    }
	}catch(IOException e){
	    System.err.println("" + e);
	    assert(false);
	}catch(Throwable t){
	    t.printStackTrace();
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected Socket socket;
    protected Hashtable mailBoxTable;
}
