//---------------------------------------------------------------------------
// LMMailBox: Used to wait for locks
//---------------------------------------------------------------------------
public class LMMailBox{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public LMMailBox()
    {
	this.packet = null;
    }

    //-----------------------------------------------------------------------
    // Wait for a lock token to arrive
    //-----------------------------------------------------------------------
    public synchronized LMReplyPacket waitLockMsg()
    {
	LMReplyPacket replyPacket = null;

	while(this.packet == null){
	    try{
		this.wait();
	    }catch(InterruptedException e){
		System.err.println("" + e);
	    }
	}
	replyPacket = this.packet;
	this.packet = null;
	return(replyPacket);
    }

    //-----------------------------------------------------------------------
    // Called when LMListener gets a lock
    //-----------------------------------------------------------------------
    public synchronized void lockArrived(LMReplyPacket packet)
    {
	this.packet = packet;
	this.notifyAll();
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected LMReplyPacket packet;
}
