//---------------------------------------------------------------------------
// LockBlockThread: Thread that blocks for a lock to sends to the replica FSM
//---------------------------------------------------------------------------

public class LockBlockThread implements Runnable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public LockBlockThread(ReplicaFSM fsm, LMMailBox mBox)
    {
	this.fsm = fsm;
	this.mbox = mBox;
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	LMReplyPacket packet = null;

	packet = this.mbox.waitLockMsg();
	this.fsm.applyMsg(packet);
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected ReplicaFSM fsm;
    protected LMMailBox mbox;
}
