import java.io.IOException;
import java.net.InetAddress;
import java.util.Hashtable;

//---------------------------------------------------------------------------
// MQReceiver: Implement the receiving end point of a simple message queue
//---------------------------------------------------------------------------
public class MQReceiver{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public MQReceiver(String endPointAddress, int portNum) throws IOException
    {
	Integer portNumInt = null;
	InetAddress address = null;
	MQQueuePool queuePool = null;

	if(MQReceiver.queuePoolPool == null){
	    // First time this constructor is called on this machine
	    MQReceiver.queuePoolPool = new Hashtable();
	}
	portNumInt = new Integer(portNum);
	queuePool = (MQQueuePool)MQReceiver.queuePoolPool.get(portNumInt);
	if(queuePool == null){
	    // First time constructor is called with this port number
	    queuePool = new MQQueuePool();
	    MQReceiver.queuePoolPool.put(portNumInt, queuePool);
	    new MQServer(queuePool, portNum);
	}
	address = InetAddress.getByName(endPointAddress);
	this.recvQueue = queuePool.getQueue(address);
    }

    //-----------------------------------------------------------------------
    // Extract a message from the queue
    //-----------------------------------------------------------------------
    public OriginMsg dequeue()
    {
	OriginMsg msg = null;

	msg = (OriginMsg)this.recvQueue.peekBlocked();
	this.recvQueue.dequeue();
	return(msg);
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    private static Hashtable queuePoolPool = null;
    private SyncQueue recvQueue;
}
