import java.io.IOException;
import java.net.InetAddress;

//---------------------------------------------------------------------------
// MQSender: Implement the sending end point of a simple message queue
//---------------------------------------------------------------------------
public class MQSender{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public MQSender(String endPointAddress,
		    int portNum) throws IOException
    {
	InetAddress address = null;

	address = InetAddress.getByName(endPointAddress);
	this.sendQueue = new SyncQueue();
	new MQSendThread(this.sendQueue, address, portNum);
    }

    //-----------------------------------------------------------------------
    // Insert a message to be sent
    //-----------------------------------------------------------------------
    public void enqueue(OriginMsg msg)
    {
	this.sendQueue.enqueue(msg);
    }

    //-----------------------------------------------------------------------
    // Private data
    //-----------------------------------------------------------------------
    private SyncQueue sendQueue;
}
