//---------------------------------------------------------------------------
// Implementation of a TCP Nice Socket object
//---------------------------------------------------------------------------
import java.net.Socket;
import java.net.SocketImpl;
import java.net.SocketException;
import java.io.IOException;

public class NiceSocket extends Socket{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public NiceSocket(String serverName, int portNum) throws IOException
    {
	this(new NiceSocketImpl(), serverName, portNum);
    }

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    protected NiceSocket(NiceSocketImpl socketImpl,
			 String serverName,
			 int portNum) throws IOException
    {
	super(socketImpl);
	this.niceSocketImpl = socketImpl;
	this.niceSocketImpl.create(true);
	this.niceSocketImpl.connect(serverName, portNum);
    }

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public NiceSocket(NiceSocketImpl socketImpl) throws IOException
    {
	super(socketImpl);
    }

    //-----------------------------------------------------------------------
    // Return true if the socket is connected
    //-----------------------------------------------------------------------
    public boolean isConnected()
    {
	return(true);
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected NiceSocketImpl niceSocketImpl;
}
