//---------------------------------------------------------------------------
// OldDataThread: Low-priority thread that reapplies old data messages
//
// TODO: Make this a low-priority thread
//---------------------------------------------------------------------------
public class OldDataThread extends AtomicThread{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public OldDataThread(OriginQueueFSM fsm, 
			 OldDataPool oldDataPool,
			 BooleanLock lock)
    {
	super(lock);
	this.fsm = fsm;
	this.oldDataPool = oldDataPool;
	this.startSelf();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	OriginMsg dataMsg = null;

	try{
	    while(true){
		this.oldDataPool.waitForData();
		this.enterCriticalSection();
		if(!this.oldDataPool.isEmpty()){
		    dataMsg = this.oldDataPool.dequeuePriority();
		    this.fsm.handleOldData(dataMsg);
		    dataMsg = null;
		}
		this.exitCriticalSection();
	    }
	}catch(Throwable t){
	    t.printStackTrace();
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected OriginQueueFSM fsm;
    protected OldDataPool oldDataPool;
}
