//---------------------------------------------------------------------------
// OriginMsgApplyThread: Thread that makes calls into the replica FSM
//---------------------------------------------------------------------------
public class OriginMsgApplyThread implements Runnable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public OriginMsgApplyThread(ReplicaFSM replicaFSM, SyncQueue localQueue)
    {
	this.replicaFSM = replicaFSM;
	this.localQueue = localQueue;
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	OriginMsg msg = null;

	try{
	    while(true){
		msg = (OriginMsg)this.localQueue.peekBlocked();
		this.localQueue.dequeue();
		/*
		System.out.println("OriginMsgApplyThread: " +
				   this.localQueue.size());
		*/
		this.replicaFSM.applyMsg(msg);
		msg = null;
	    }
	}catch(Throwable t){
	    t.printStackTrace();
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected ReplicaFSM replicaFSM;
    protected SyncQueue localQueue;
}
