//---------------------------------------------------------------------------
// PQEntry: Represents an entry in the priority queue
//---------------------------------------------------------------------------
public class PQEntry implements Comparable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public PQEntry(String objectID, long seqNum, double priority)
    {
	this.objectID = objectID;
	this.priority = priority;
	this.seqNum = seqNum;
    }

    //-----------------------------------------------------------------------
    // Return the object ID
    //-----------------------------------------------------------------------
    public String getObjectID()
    {
	return(this.objectID);
    }

    //-----------------------------------------------------------------------
    // Return the priority
    //-----------------------------------------------------------------------
    public double getPriority()
    {
	return(this.priority);
    }

    //-----------------------------------------------------------------------
    // Return the sequence number
    //-----------------------------------------------------------------------
    public long getSeqNum()
    {
	return(this.seqNum);
    }

    //-----------------------------------------------------------------------
    // Return <0 if this < o, >0 if this > o, or 0 if this == o
    //-----------------------------------------------------------------------
    public int compareTo(Object o)
    {
	PQEntry pqe = null;
	int result = 0;

	pqe = (PQEntry)o;
	if(this.priority < pqe.priority){
	    result = -1;
	}else if(this.priority > pqe.priority){
	    result = 1;
	}else{
	    // Same priorities; disambiguate based on object ID
	    result = this.objectID.compareTo(pqe.objectID);
	}
	return(result);
    }

    //-----------------------------------------------------------------------
    // Return true if this == o
    //-----------------------------------------------------------------------
    public boolean equals(Object o)
    {
	PQEntry pqe = null;
	
	pqe = (PQEntry)o;
	return((this.priority == pqe.priority) &&
	       (this.objectID.equals(pqe.objectID)));
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected String objectID;
    protected double priority;
    protected long seqNum;
}
