//---------------------------------------------------------------------------
// Replica: Starting point for a replica
//---------------------------------------------------------------------------
import java.io.IOException;

public class Replica{

    //-----------------------------------------------------------------------
    // Program starting point
    //-----------------------------------------------------------------------
    public static void main(String[] argv)
    {
	String serverName = null;
	int tcpPortNum = 0;
	int nicePortNum = 0;
	int ackPortNum = 0;
	long timeout = 0L;
	int sleepPort = 0;
	ReplicaFSM replicaFSM = null;

	if(argv.length == 6){
	    serverName = argv[0];
	    tcpPortNum = Integer.parseInt(argv[1]);
	    nicePortNum = Integer.parseInt(argv[2]);
	    ackPortNum = Integer.parseInt(argv[3]);
	    timeout = Long.parseLong(argv[4]);
	    sleepPort = Integer.parseInt(argv[5]);
	    System.out.println("timeout = " + timeout);

	    try{
		replicaFSM = new ReplicaFSM(serverName,
					    tcpPortNum,
					    ackPortNum,
					    nicePortNum,
					    timeout);
		new FSCommServer(replicaFSM);
		TestbedWait.waitForTestStart(sleepPort);
		replicaFSM.startReplica();
	    }catch(IOException e){
		System.err.println("Replica failed to start: " + e);
		assert(false);
	    }
	}else{
	    System.err.println("Usage: Replica <serverName> <tcpPortNum>" +
			       " <nicePortNum> <ackPortNum> <timeout>" +
			       " <sleepport>");
	}
    }
}
