import java.io.IOException;

//---------------------------------------------------------------------------
// APMQTest: Test the message queue
//---------------------------------------------------------------------------
public class APMQTest{

    //-----------------------------------------------------------------------
    // Program starting point
    //-----------------------------------------------------------------------
    public static void main(String[] argv)
    {
	OriginMsg msg = null;
	String endPointAddress = null;
	APMQSender sp1 = null;
	APMQReceiver rp1 = null;
	int num = 3;
	long s = 0;
	byte[] b = null;
	byte[] b1 = null;

	try{
	    if((argv.length == 2) && (argv[0].equals("client"))){
		// Client
		endPointAddress = argv[1];
		sp1 = new APMQSender(endPointAddress, 4555, 4989);
		s = sp1.getSeqNum();
		s++;
		b1 = new byte[2];
		while(true){
		    b1[0] = (byte)num;
		    num++;
		    sp1.enqueue(new OriginMsg(s, AppMessage.READ, null, b1));
		    s++;
		    Thread.sleep(1000);
		}
	    }else if((argv.length == 2) && (argv[0].equals("server"))){
		// Server
		endPointAddress = argv[1];
		rp1 = new APMQReceiver(endPointAddress, 4555, 4989);
		while(true){
		    msg = rp1.dequeue();
		    b = msg.getData();
		    System.out.println("seqNum = " + msg.getSeqNum() +
				       ", data = " + b[0]);
		    if((msg.getSeqNum() % 25) == 0){
			rp1.sendAck(msg.getSeqNum());
		    }
		}
	    }else{
		System.err.println("Usage: java APMQTest {client | server}" +
				   " address");
	    }
	}catch(IOException e){
	    Assert.affirm(false);
	}catch(InterruptedException e){
	    Assert.affirm(false);
	}catch(ReplicaUnreceptiveException e){
	    Assert.affirm(false);
	}
    }
}
