import java.net.Socket;
import java.io.IOException;

//---------------------------------------------------------------------------
// TestbedSignal: Provide a standard means for machines to be woken up
//---------------------------------------------------------------------------
public class TestbedSignal{
    //-----------------------------------------------------------------------
    // Program starting point
    //-----------------------------------------------------------------------
    public static void main(String[] argv)
    {
	int portNum = 0;
	Socket[] sockets = null;

	try{
	    System.out.println("Starting now!");
	    sockets = new Socket[argv.length / 2];
	    for(int i = 0; i < argv.length / 2; i++){
		portNum = Integer.parseInt(argv[(2 * i) + 1]);
		System.out.println("Waking: " + argv[2 * i] + ":" + portNum);
		sockets[i] = new Socket(argv[2 * i], portNum);
		sockets[i].setTcpNoDelay(true);
	    }
	}catch(IOException e){
	    System.err.println("TestbedSignal (main 1): " + e);
	}finally{
	    if(sockets != null){
		for(int i = 0; i < sockets.length; i++){
		    if(sockets[i] != null){
			try{
			    sockets[i].close();
			}catch(IOException e){}
			sockets[i] = null;
		    }
		}
		sockets = null;
	    }
	}
    }
}
