import java.net.Socket;
import java.net.ServerSocket;

import java.io.IOException;
import java.util.Vector;

//---------------------------------------------------------------------------
// TestbedWait: Provide a standard means for machines to wait to be woken
//---------------------------------------------------------------------------
public class TestbedWait{

    //-----------------------------------------------------------------------
    // Wait until woken by an external connection
    //-----------------------------------------------------------------------
    public static void waitForTestStart(int portNum)
    {
	Socket socket = null;
	ServerSocket serverSocket = null;

	try{
	    System.out.println("Waiting to be started");
	    serverSocket = new ServerSocket(portNum);
	    socket = serverSocket.accept();
	    socket.setTcpNoDelay(true);
	    System.out.println("Starting....");
	}catch(IOException e){
	    System.err.println("TestbedWait (waitForTestStart 1): " + e);
	}finally{
	    if(socket != null){
		try{
		    socket.close();
		}catch(IOException e){}
		socket = null;
	    }
	    if(serverSocket != null){
		try{
		    serverSocket.close();
		}catch(IOException e){}
		serverSocket = null;
	    }
	}
    }

    //-----------------------------------------------------------------------
    // Used for testing
    //-----------------------------------------------------------------------
    public static void main(String[] argv)
    {
	TestbedWait.waitForTestStart(21633);
	System.out.println("Can start now!");
    }
}
