//---------------------------------------------------------------------------
// LMListener: Thread used to communicate with the lock manager
//---------------------------------------------------------------------------
import java.net.Socket;
import java.io.InputStream;
import java.io.IOException;

public class LMListener implements Runnable{

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public LMListener(Socket socket, LMCommPoint lmCommPoint)
    {
	this.socket = socket;
	this.lmCommPoint = lmCommPoint;
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	AppMessage msg = null;
	InputStream is = null;
	LMReplyPacket reply = null;

	try{
	    is = this.socket.getInputStream();
	    while(true){
		reply = new LMReplyPacket(is);
		this.lmCommPoint.acceptLockMessage(reply);
		reply = null;
	    }
	}catch(IOException e){
	    System.err.println("" + e);
	    assert(false);
	}catch(Throwable t){
	    t.printStackTrace();
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected Socket socket;
    protected LMCommPoint lmCommPoint;
}
