//---------------------------------------------------------------------------
// FSCommServer: Listens to requests from the FS
//---------------------------------------------------------------------------
import java.net.Socket;
import java.net.ServerSocket;
import java.io.IOException;
import java.io.InputStream;

public class FSCommServer implements Runnable{

    //-----------------------------------------------------------------------
    // Constants
    //-----------------------------------------------------------------------
    public static final int PORT_NUM = 8888;

    //-----------------------------------------------------------------------
    // Constructor
    //-----------------------------------------------------------------------
    public FSCommServer(ReplicaFSM replicaFSM)
    {
	this.replicaFSM = replicaFSM;
	(new Thread(this)).start();
    }

    //-----------------------------------------------------------------------
    // Main thread method
    //-----------------------------------------------------------------------
    public void run()
    {
	Socket socket = null;
	InputStream is = null;
	FSCommPacket fsPacket = null;
	ServerSocket serverSocket = null;

	try{
	    serverSocket = new ServerSocket(FSCommServer.PORT_NUM);
	    while(true){
		socket = serverSocket.accept();
		is = socket.getInputStream();
		fsPacket = new FSCommPacket(is, socket);
		Globals.debugPrintln("FSCommServer: Got a request");
		Globals.debugPrintln("type = " + fsPacket.getMessageType());
		Globals.debugPrintln("objectID = " + fsPacket.getObjectID());
		Globals.debugPrintln("");
		this.replicaFSM.applyMsg(fsPacket);
		// is.close(); ?
	    }
	}catch(IOException e){
	    assert(false);
	}
    }

    //-----------------------------------------------------------------------
    // Protected data
    //-----------------------------------------------------------------------
    protected ReplicaFSM replicaFSM;
}
